// Copyright(c) 2014 i.system.create.inc. All Rights Reserved.

//定数定義
var ROW = 14;
var COL = 20;
var cellSize = 50;
var mixer = null;
var timer = false;
var bm = null;

//状態保持
var clickedHash = {};
var coloredHash = {};

var nameFontSizeNormal = "";
var nameFontSizeSmall = "";

var symbolFontSizeNormal = 0;
var symbolFontSizeSmall = 0;

// 表示モード(0:通常 1:チャレンジモード)
var pageMode = 0;

var challenge = "";

var challengeAnswerLatest = null;

// ヒントモード状態フラグ
var hintMode = false;

// チャレンジモード状態フラグ
var challengeMode = false;

// iOSか否か
function isIOS() {
if ((navigator.userAgent.indexOf('iPhone') != -1) || (navigator.userAgent.indexOf('iPod') != -1) || (navigator.userAgent.indexOf('iPad') != -1)) {
	return true;
	}
}

// オーディオ初期化
function initAudioRef() {
 loadChoiceRef = document.getElementById("loadChoice");
 loadCancelRef = document.getElementById("loadCancel");
 loadResetRef = document.getElementById("loadReset");
 loadClickResetRef = document.getElementById("loadClickReset");
 loadChanceRef = document.getElementById("loadChance");
 loadAnswerRef = document.getElementById("loadAnswer");
}

var loadChoiceRef = null;
var loadCancelRef = null;
var loadResetRef = null;
var loadClickResetRef = null;
var loadChanceRef = null;
var loadAnswerRef = null;

//動的コンテンツロード処理
var loadDynamicContents = function() {

	//起動引数の取得
	var tmpArgs = document.location.search.substring(1);
	pageMode = tmpArgs.replace("mode=","");
	//alert(mode);

	//画面サイズの調整
	resizeContents();	// <- この中でセルサイズが決定される
	
	var clickedHash = {};
	var coloredHash = {};

	//ヘッダー部のボタンセット
	setHeaderButtons();
	//詳細表示用領域セット
	setDetailArea();
	//ポップアップ表示領域セット
	//setPopupArea();
	//改行の大きさを調整
	$('.divBr1').height(cellSize / 5);
	$('.divBr2').height(cellSize / 2);
	//中央に表示する
	alignContents2Center();
	
	//各グリッドを生成
	createGrid('mainGrid', 7, 18, true);
	createGrid('lanthanoidGrid', 1, 15, false);
	createGrid('actinideGrid', 1, 15, false);
	//データ注入
	insertContents2Grid('mainGrid', [gridContents, 'main']);
	insertContents2Grid('lanthanoidGrid', [gridContents, 'lanthanoid']);
	insertContents2Grid('actinideGrid', [gridContents, 'actinide']);
	//族番号のフィット
	fitHeadline();
	//ランタノイドとアクチノイドをセット
	setLantActi2mainGrid();
	//ミキサークラス生成
	mixer = new Mixer();
	mixer.attach(gridContents);
    
    //通常モードではチャレンジボタンを表示しない
    if ( pageMode == 0) {
        $('#chanceButton').css('display','none');
        $('#hintButton').css('display','none');
    }
	
	
};

//画面サイズの調整
var resizeContents = function() {
	var ww = $(window).width();
	var wh = $(window).height();
	var rate = wh / ww;
	if(ROW / COL < rate) {
		//縦が長い場合 横を優先する
		cellSize = ww / COL;
	} else {
		//横が長い場合 縦を優先する
		cellSize = wh / ROW;
	}
	//ウィンドウサイズが小さすぎる場合，ツールバーの影響が大きくなるため何かするか？
	//そもそも解像度的に厳しいので表示不可エラーとして握りつぶしてしまうのもあり？
}

//中央に表示する
var alignContents2Center = function() {
	var dw = $(window).width() - cellSize * COL;
	if(!(dw < 0)) {
		$('#bg').css('left', (dw / 2) + 'px');
	}
}

// チャレンジの正解表示
var onClickAnswerButton = function(event) {
    
    //alert('1seikai ');
    // 一時的な強調を元に戻す
    for(var cli in clickedHash){
        var clickedObject = $('#' + cli);
        if ( clickedObject.hasClass('clicked') == true) {
            // 強調を戻す
            clickedObject.css({'backgroundColor' : '#c0c0c0' ,'color':'#c0c0c0'});
        }
    }

    
    // 正解表示
    var clickedObject = $('#' + challenge);
    
    challengeAnswerLatest = clickedObject;
    
    //alert(challenge);
    
    bm.blinkAnswer(clickedObject);
    
    var bmCollection = $('#' + challenge);
    bm.init(bmCollection);
    
    loadChoiceRef.pause();
    if (!isIOS()) {
        try{
            loadChoiceRef.currentTime = 0;
        }catch(eee) { }
    }
    loadAnswerRef.play();
    

    
    // 通常表示を行いロック解除
    var arrGridContents = gridContents;
	for (var i = 0; i < arrGridContents.length; i++) {
		var cellId = arrGridContents[i].type + 'Grid-r' + arrGridContents[i].row + 'c' + arrGridContents[i].column;
        if ( cellId == challenge) {
            
            $('#featurea')
            .text('特徴・主な用途')
            .css('color','#000000');
            
            $('#selectedContent').css('background-color','#3498db');
            
            $('#selectedContent-symbol').text(arrGridContents[i].symbol);
            if ( arrGridContents[i].symbol.length > 2) {
                $('#selectedContent-symbol')
                .css('font-size', symbolFontSizeSmall + 'px')
                .css('top', symbolFontSizeNormal * 0.4 + 'px');
            } else {
                $('#selectedContent-symbol')
                .css('font-size', symbolFontSizeNormal + 'px')
                .css('top', symbolFontSizeNormal * 0.3 + 'px');
            }
            
            $('#selectedContent-serialNumber').text(arrGridContents[i].serialNumber);
            $('#selectedContent-name').text(arrGridContents[i].name);
            if ( arrGridContents[i].name.length > 6 ) {
                $('#selectedContent-name').css('font-size' , nameFontSizeSmall);
            } else  {
                $('#selectedContent-name').css('font-size' , nameFontSizeNormal);
            }
            
            $('#selectedContent-detail').text(arrGridContents[i].detail);
            $('#selectedContent-detail2').text('');
            
            break;
        }
    }
    
    
    // 3秒で元の表示にもどす
    setTimeout(function(){
               
               // 未選択アイコンを元の色に
               var arrGridContents = gridContents;
               for (var i = 0; i < arrGridContents.length; i++) {
               	var cellId = arrGridContents[i].type + 'Grid-r' + arrGridContents[i].row + 'c' + arrGridContents[i].column;
                   if ( clickedHash[cellId] == null) {
                       var normalObject = $('#' + cellId);
                       normalObject.css({'backgroundColor' : gridContents[i].color ,'color':'#ffffff'});
                   }
               }
               
    } , 3000);
    
    // false
    challengeMode = false;
    
}

var resetChangeLatest = function() {
    
    // 通常時は関係なし
    if ( pageMode == 0) {
        return;
    }
    
    hintMode = true; // to false
    onClickHintButton();
    
    if ( challengeAnswerLatest != null) {
        challengeAnswerLatest.css({'backgroundColor' : '#c0c0c0' , 'color' : '#c0c0c0'});
        challengeAnswerLatest = null;
    }
}

//ヒントボタンクリック時の処理
var onClickHintButton = function(event) {
    
    if ( clickedHash == null) {
        alert('まだなにも選択されていません。');
        return;
    }
    var cnt = 0;
    for(var cli in clickedHash){
        cnt++;
    }
    if(cnt == 0) {
        alert('まだなにも選択されていません。');
        return;
    }
    //alert('koko?');
    

    // 反転
    if ( hintMode ) {
        hintMode = false;

        for(var cli in clickedHash){
            var clickedObject = $('#' + cli);
            clickedObject.css({'backgroundColor' : '#c0c0c0' ,'color':'#c0c0c0'});
        }
    
    } else {
        loadClickResetRef.play();
        hintMode = true;
        
        for(var cli in clickedHash){
            var clickedObject = $('#' + cli);
            clickedObject.css({'backgroundColor' : '#c0c0c0' ,'color':'#ffffff'});
        }
        
    }

}

//チャレンジボタンクリック時の処理
var onClickChanceButton = function(event) {
    
    //alert('aa');
    
    resetChangeLatest();
    
    bm.blink([{'id':'dmy'}]);
    
    var selectedStr = '';
    //for (var cli in clickedHash) {
    //    var clickedObject = $('#' + cli);
    //    if ( clickedObject.hasClass('clicked') == true) {
    //        selectedStr += cli + ' ' ;
    //    }
    //}
    
    // random select
    var objLength = 0;
    var ary = [];
    for(var cli in clickedHash){
        var clickedObject = $('#' + cli);
        if ( clickedObject.hasClass('clicked') == true) {
            selectedStr += cli + ' ' ;
            objLength++;
            ary.push(cli);
            // 強調
            clickedObject.css({'backgroundColor' : '#FFD700' ,'color':'#FFD700'});
        }
    }
    
    if ( ary.length == 0) {
        //alert('まだなにも選択されていませんA。');
        return;
    }
    
    var rand = Math.floor(Math.random() * objLength);
    var randselect = ary[rand];
    
    // 未選択アイコンを一時的にグレーに
    var arrGridContents = gridContents;
	for (var i = 0; i < arrGridContents.length; i++) {
		var cellId = arrGridContents[i].type + 'Grid-r' + arrGridContents[i].row + 'c' + arrGridContents[i].column;
        if ( clickedHash[cellId] == null) {
            var normalObject = $('#' + cellId);
            normalObject.css({'backgroundColor' : '#c0c0c0' ,'color':'#d6d6d6'});
        }
    }
    
    //alert('TODO ' + selectedStr);
    //alert(randselect);

    // チャンレジ表示
    var arrGridContents = gridContents;
	for (var i = 0; i < arrGridContents.length; i++) {
		var cellId = arrGridContents[i].type + 'Grid-r' + arrGridContents[i].row + 'c' + arrGridContents[i].column;
        if ( cellId == randselect) {
    
            //'alert('find!' + arrGridContents[i].symbol );
            
            loadChanceRef.play();

            $.fn.custombox( this, {
                           url : "#modal",
                           overlay: true,
                           effect: 'fall'
                           });
            
            
            $('#detailArea')
            .removeClass('hidden')
            .css({'opacity': '0'})
            .animate({'opacity': '1'}, 750);
            
            challenge = randselect;
    
            $('#featurea')
            .html('' + '<button onclick="onClickAnswerButton();" class="button7">正解は・・・</button>');
            
            $('#selectedContent').css('background-color','red');
            
            $('#selectedContent-symbol').text(arrGridContents[i].symbol);
            if ( arrGridContents[i].symbol.length > 2) {
                $('#selectedContent-symbol')
                .css('font-size', symbolFontSizeSmall + 'px')
                .css('top', symbolFontSizeNormal * 0.4 + 'px');
            } else {
                $('#selectedContent-symbol')
                .css('font-size', symbolFontSizeNormal + 'px')
                .css('top', symbolFontSizeNormal * 0.3 + 'px');
            }
            
            $('#selectedContent-serialNumber').text('??');
            $('#selectedContent-name').text(arrGridContents[i].name);
            if ( arrGridContents[i].name.length > 6 ) {
                $('#selectedContent-name').css('font-size' , nameFontSizeSmall);
            } else  {
                $('#selectedContent-name').css('font-size' , nameFontSizeNormal);
            }
            
            $('#selectedContent-detail').text('チャレンジタイム！！');
            $('#selectedContent-detail2').html('<br/>この元素はどこに入る？').css('color','red');
            
            challengeMode = true;
            
            break;
        }
    }
    
}

//リセットボタンクリック時の処理
var onClickResetButton = function(event) {
    
    if ( challengeMode ) { return; }
    
    resetChangeLatest();
    
	loadClickResetRef.play();
	if(window.confirm('パネルをリセットします\nよろしいですか？')){
		// $('.clickedButton').toggleClass('clickedButton');
		for (var cli in clickedHash) {
			var clickedObject = $('#' + cli);
			clickedObject.removeClass('clicked').css({
				'backgroundColor' : coloredHash[cli],
                'color' : '#ffffff',
				'opacity': '1',
			});
		}
		
		bm = new BlinkManager();
		
		clickedHash = {};
		
		//現在のミキサーを破棄し，新たなミキサーにデータをアタッチし直す
		mixer = new Mixer();
		mixer.attach(gridContents);

		loadResetRef.play();

		//詳細エリアが消えないのは変な感じなので消す
		//$('#toggleHeadlineButton').trigger('click', [true]);
		$('#detailArea').addClass('hidden')
		//一応詳細も空にしておく
		$('#selectedContent-symbol').text('');
		$('#selectedContent-serialNumber').text('');
		$('#selectedContent-name').text('');
		$('#selectedContent-detail').text('');
		
		$('#PPselectedContent-symbol').text('');
		$('#PPselectedContent-serialNumber').text('');
		$('#PPselectedContent-name').text('');
		$('#PPselectedContent-detail').text('');
		$('#PPselectedContent-detail2').text('');
        
        //
        //ランタノイド
        $('#ltxt1').css({'color' : '#000000'});
        $('#ltxt2').css({'color' : '#000000'});
        //アクチノイド
        $('#atxt1').css({'color' : '#000000'});
        $('#atxt2').css({'color' : '#000000'});
	}
}

/*
// 見出し切替えボタンクリック時の処理
var onClickToggleHeadlineButton = function(event) {
	var headLine = $('.r0, .c0');
	var da = $('#detailArea');
	headLine.toggleClass('displayNone');
	if(da.hasClass('hidden')) {
		//内容がある場合のみ表示
		if($('#selectedContent-symbol').text()) {
			da.removeClass('hidden');
		}
	} else {
		da.addClass('hidden')
	}
}
*/

//ランダムボタンクリック時の処理
var onClickRandomButton = function(event) {
    
    if ( challengeMode ) { return; }
   
    
	//モーダルウィンドウの表示状態で処理を分岐する
	if($('body:has(#custombox-modal)').length > 0) {
		//モーダルウィンドウ表示中もEnterキーが効くので
		//その時は選択せずクローズする
		$.fn.custombox('close');
	} else {
        
        resetChangeLatest();
        
		//モーダルウィンドウが表示されていない場合は通常のクリック処理
		var popData = mixer.pop();
		if(popData) {
			$('#' + popData.type +'Grid-r' + popData.row + 'c' + popData.column).trigger('click', [true]);
		} else {
			alert('すべて選択されています');
		}
	}
}

var blinkCounter = 0;
var BlinkManager = function() {};
BlinkManager.prototype.init = function(clickedObject) {
	this.clickedObject = clickedObject;
};
BlinkManager.prototype.blink = function(clickedObject) {
	if(this.clickedObject && this.clickedObject.hasClass('clicked') && this.clickedObject[0].id != clickedObject[0].id){
		// 通常モード時は消さない。
		if ( pageMode != 0) {
            this.clickedObject.css({'backgroundColor' : '#c0c0c0' , 'color' : '#c0c0c0'});
			//this.clickedObject.animate({opacity: '0'}, {duration: 750});
		}
	}
};
BlinkManager.prototype.blinkAnswer = function(clickedObject) {
	clickedObject.animate({opacity: '1'}, {duration: 750});
    clickedObject.css({'backgroundColor' : '#fc3c3c' , 'color' : '#ffffff'});
    //alert('TODO戻せてない');
};
BlinkManager.prototype.clickedObject = null;
BlinkManager.prototype.orgColor = null;
BlinkManager.prototype.clickedColor = null;
/*blinkStop = function() {
	blinkCounter = 0;
	if(blinkSwitch){
		blinkSwitch = false;
		bm._clickedObject.animate({opacity: '0'}, {duration: 750});
	}
};*/
/*blink = function() {
	if(blinkSwitch){
		if(blinkCounter % 2 == 0) {
			var op = '0.3';
			blinkCounter++;
		} else {
			var op = '1';
			blinkCounter++;
		}
		bm._clickedObject.animate({opacity: op}, {duration: 750, complete: blink});
	}
};*/

//セルクリック時の処理
//@param isForced {Boolean} ランダムボタン押下: true / セルクリック: false
var onClickGridContent = function(event, isForced) {
    
    if ( challengeMode ) { return; }
    
	var clickedObject = $('#' + event.data.id);
	//var isClicked = clickedObject.toggleClass('clickedButton').hasClass('clickedButton');
	var bmCollection = null;
	
	var isClicked = false;
	if ( clickedHash[event.data.id] == null ) {
		isClicked = true;
		clickedHash[event.data.id] = coloredHash[event.data.id];
		//clickedObject.css({'backgroundColor' : '#fc3c3c'});
		clickedObject.addClass('clicked');
		var arrCellInfo = event.data.id.split('-');
		var actGrid = arrCellInfo[0];
		var tmpIndex = arrCellInfo[1].indexOf('c');
		var actRow = arrCellInfo[1].substring(1, tmpIndex);
		var actCol = arrCellInfo[1].substring(tmpIndex + 1);
		var tmpId = '';
		switch(actGrid) {
			case 'mainGrid':
				//maingridの場合は同族元素を選択
				var arrClickedObjects = $('.clicked' + '.' + actGrid + '.c' + actCol);
				arrClickedObjects.sort();	//一応アルファベット順でソート
				var minId = arrClickedObjects[0].id;
				var maxId = arrClickedObjects[arrClickedObjects.length - 1].id;
				var strCollection = '';			//セレクター指定するための文字列
				var arrSelected = [];			//mixerから取り除くものを退避しておく配列
				// 通常モードの場合は選択されたもののみ
				if  ( pageMode != 0 ) {
                    // mainGridはチャレンジモードでも通常にする
					//for(var i = 1; i < 8; i++) {
					//	tmpId = 'mainGrid' + '-r' + i + 'c' + actCol;
					//	if(minId <= tmpId && tmpId <= maxId) {
					//		if(strCollection != '') {
					//			strCollection += ',';
					//		}
					//		strCollection = strCollection + '#' + tmpId;
					//
					//		arrSelected.push(tmpId);
					//	}
					//}
					// alert(strCollection);
					//bmCollection = $(strCollection);
					bmCollection = $('#' + event.data.id);
					// alert(	event.data.id);
					arrSelected.push(event.data.id);
				} else {
					bmCollection = $('#' + event.data.id);
					// alert(	event.data.id);
					arrSelected.push(event.data.id);
				}

				for(var i = 0; i < gridContents.length; i++) {
					tmpId = gridContents[i].type + 'Grid-r' + gridContents[i].row + 'c' + gridContents[i].column;
					for(var j = 0; j < arrSelected.length; j++) {
						if(tmpId == arrSelected[j] && tmpId != event.data.id) {
							mixer.remove(i);
						}
					}
				}

				break;

			//ランタノイドorアクチノイドの場合は，その全てを選択
			case 'lanthanoidGrid':
			case 'actinideGrid':
				var type = actGrid.substring(0, actGrid.indexOf('Grid'))
				// 通常モードの場合は選択されたもののみ
				if  ( pageMode != 0 ) {
					bmCollection = $('.' + actGrid);
                    
                    if ( actGrid == 'lanthanoidGrid') {
                        //ランタノイド
                        $('#ltxt1').css({'color' : 'red'});
                        $('#ltxt2').css({'color' : 'red'});
                    } else {
                        //アクチノイド
                        $('#atxt1').css({'color' : 'red'});
                        $('#atxt2').css({'color' : 'red'});
                    }
                    
                    
				} else {
					bmCollection =  $('#' + event.data.id);
				}

				for(var i = 0; i < gridContents.length; i++) {
					if(gridContents[i].type == type) {
						tmpId = gridContents[i].type + 'Grid-r' + gridContents[i].row + 'c' + gridContents[i].column;
						if(tmpId != event.data.id) {
                            if  ( pageMode != 0 ) {
                                mixer.remove(i);
                            }
						}
					}
				}
				break;

			default:
				break;
		}
		
        //if ( pageMode != 1) {
            bmCollection.addClass('clicked').css({'backgroundColor' : '#fc3c3c', 'color' : '#ffffff'});
        //} else {
        //    bmCollection.addClass('clicked').css({'backgroundColor' : '#c0c0c0' , 'color' : '#c0c0c0'});
        //}
		for(var i = 0; i < bmCollection.length; i++) {
			clickedHash[bmCollection[i].id] = coloredHash[bmCollection[i].id];
		}
	} else {
		clickedHash[event.data.id] = null;
		clickedObject.css({'backgroundColor' : coloredHash[event.data.id]});
	}
	//alert(isClicked);
	
	if(isClicked) {
		
		//alert(event.data.gridContent.name);
//        resetChangeLatest();
        
		//新規選択の場合
		bm.blink(clickedObject);
		/*if(!$('.r0, .c0').hasClass('displayNone')){
			$('.r0, .c0').toggleClass('displayNone');
		}*/
        
        $('#featurea')
        .text('特徴・主な用途')
        .css('color','#000000');
        
        $('#selectedContent').css('background-color','#3498db');

        
		$('#selectedContent-symbol').text(event.data.gridContent.symbol);
		if ( event.data.gridContent.symbol.length > 2) {
			$('#selectedContent-symbol')
			.css('font-size', symbolFontSizeSmall + 'px')
			.css('top', symbolFontSizeNormal * 0.3 + 'px');
		} else {
			$('#selectedContent-symbol')
			.css('font-size', symbolFontSizeNormal + 'px')
			.css('top', symbolFontSizeNormal * 0.2 + 'px');
		}
		
		$('#selectedContent-serialNumber').text(event.data.gridContent.serialNumber);
		$('#selectedContent-name').text(event.data.gridContent.name);
		if ( event.data.gridContent.name.length > 6 ) {
			$('#selectedContent-name').css('font-size' , nameFontSizeSmall);
		} else  {
			$('#selectedContent-name').css('font-size' , nameFontSizeNormal);
		}

		$('#selectedContent-detail').text(event.data.gridContent.detail);
		$('#selectedContent-detail2').text('');

		
		/*
		$('#PPselectedContent-symbol').text(event.data.gridContent.symbol);
		if ( event.data.gridContent.symbol.length > 2) {
			$('#PPselectedContent-symbol').css('font-size', symbolFontSizeSmall + 'px');
		} else {
			$('#PPselectedContent-symbol').css('font-size', symbolFontSizeNormal + 'px');
		}

		$('#PPselectedContent-serialNumber').text(event.data.gridContent.serialNumber);
		$('#PPselectedContent-name').text(event.data.gridContent.name);
		if ( event.data.gridContent.name.length > 6 ) {
			$('#PPselectedContent-name').css('font-size' , nameFontSizeSmall);
		} else {
			$('#PPselectedContent-name').css('font-size' , nameFontSizeNormal);
		}
		
		$('#PPselectedContent-detail').text(event.data.gridContent.detail);
		
		$('#detailArea').removeClass('hidden');
		$('#PPdetailArea').removeClass('hidden');
		*/
		
		loadChoiceRef.pause();	
		if (!isIOS()) { 
			try{
				loadChoiceRef.currentTime = 0;
			}catch(eee) { }
		}
		loadChoiceRef.play();
		
		$('#detailArea')
		.removeClass('hidden')
		.css({'opacity': '0'})
		.animate({'opacity': '1'}, 750);
		//ランダムボタン押下時はミキサーにてランダムスタックから取り出しているためremoveしない
		if(!isForced){
			mixer.remove(event.data.gridContentIndex);
		}

		//bm.init(clickedObject, event.data.gridContent.color, '#fc3c3c');
		bm.init(bmCollection);

		//ダイアログFall表示
		/**
		$.fn.custombox( this, {
					   url : "#modal",
					   overlay: true,
					   effect: 'fall'
					   });
		*/	
	
	} else {
        
		//選択解除の場合
        clickedObject.css({'backgroundColor' : coloredHash[event.data.id]});
        clickedObject.css({'color' : '#ffffff'});
        
		clickedObject.animate({opacity: '1'}, {duration: 100});
		clickedObject.removeClass('clicked');
		$('#detailArea').addClass('hidden');
		//一応詳細も空にしておく
		$('#selectedContent-symbol').text('');
		$('#selectedContent-serialNumber').text('');
		$('#selectedContent-name').text('');
		$('#selectedContent-detail').text('');
		
		/*
		$('#PPselectedContent-symbol').text('');
		$('#PPselectedContent-serialNumber').text('');
		$('#PPselectedContent-name').text('');
		$('#PPselectedContent-detail').text('');
		*/
		
		loadCancelRef.play();

		//ランダムスタックにpushし，mixし直す
		mixer.push(event.data.gridContentIndex);
		mixer.mix();
	}
}

//ヘッダー部のボタンセット
var setHeaderButtons = function() {
	$('#resetButton')
	.css({
		'text-align': 'center',
		'width': cellSize * 1.5 + 'px',
		'height': cellSize / 2 + 'px',
		'font-size': cellSize / 5 + 'px',
		// 'margin-bottom': cellSize / 10 + 'px',
	});
	/*
	$('#toggleHeadlineButton')
	.css({
		'text-align': 'center',
		'width': cellSize * 1.5 + 'px',
		'height': cellSize / 2 + 'px',
		'font-size': cellSize / 5 + 'px',
		// 'margin-bottom': cellSize / 10 + 'px',
	});
	*/
	$('#randomButton')
	.css({
		'text-align': 'center',
		'width': cellSize * 1.5 + 'px',
		'height': cellSize / 2 + 'px',
		'font-size': cellSize / 5 + 'px',
		// 'margin-bottom': cellSize / 10 + 'px',
	});
}


//ポップアップ表示用領域セット
//var setPopupArea = function() {
//	var strAppendElements = '';
//	var cs = cellSize * 5;
//	var l = cs / 10;
//	var fontSize = 0;
//	
//	//子要素の追加
//	strAppendElements =
//	_createStrElement('div', 'PPexplainArea') +
//	_createStrElement('div', 'PPselectedContent');
//	$('#PPdetailArea').append(strAppendElements);
//	
//	//孫要素の追加
//	strAppendElements =
//	_createStrElement('p', 'PPfeaturea') +
//	_createStrElement('div', 'PPselectedContent-detail');
//	$('#PPexplainArea').append(strAppendElements);
//	
//	//孫要素の追加
//	strAppendElements =
//	_createStrElement('div', 'PPselectedContent-symbol') +
//	_createStrElement('div', 'PPselectedContent-serialNumber') +
//	_createStrElement('div', 'PPselectedContent-name');
//	$('#PPselectedContent').append(strAppendElements);
//	
//	//枠
//	$('#PPdetailArea')
//	.addClass('hidden')
//	.css({
//		 'width': cs * 3 + 'px',
//		 'height': cs + 'px',
//		 //'position': 'absolute',
//		 //'left': cellSize * 3 + 'px',
//		 //'top': cellSize / 2 + 'px',
//		 '-webkit-border-radius': cs / 5,
//		 '-moz-border-radius': cs / 5,
//		 'border-radius': cs / 5 + 'px',
//		 });
//	
//	//パネル
//	$('#PPselectedContent')
//	.addClass('gridButton')
//	.css({
//		 'width': cs  + 'px',
//		 'height': cs + 'px',
//		 'position': 'absolute',
//		 '-webkit-border-radius': cs / 5,
//		 '-moz-border-radius': cs / 5,
//		 'border-radius': cs / 5 + 'px',
//		 });
//	//パネル内データ
//	//元素記号
//	fontSize = l * 5;
//	
//	symbolFontSizeSmall = (fontSize * 0.8 );
//	symbolFontSizeNormal = fontSize;
//	
//	$('#PPselectedContent-symbol')
//	.css({
//		 'width': l * 5 + 'px',
//		 'height': l * 5 + 'px',
//		 'position': 'absolute',
//		 'left': l * 1 + 'px',
//		 'top': l * 1.5 + 'px',
//		 'font-size': fontSize + 'px',
//		 'text-align': 'center',
//		 });
//	//原子番号
//	fontSize = l * 1.5;
//	$('#PPselectedContent-serialNumber')
//	.css({
//		 'width': l * 2 + 'px',
//		 'height': l * 2 + 'px',
//		 'position': 'absolute',
//		 'left': l * 6 + 'px',
//		 'top': l / 2 + 'px',
//		 'font-size': fontSize + 'px',
//		 'text-align': 'right',
//		 });
//	//元素名
//	fontSize = l * 1;
//	
//	nameFontSizeSmall = (fontSize * 0.7 ) + 'px';
//	nameFontSizeNormal = fontSize + 'px';
//	
//	$('#PPselectedContent-name')
//	.css({
//		 'width': l * 8 + 'px',
//		 'height': l * 1 + 'px',
//		 'position': 'absolute',
//		 'left': l + 'px',
//		 'top': l * 8 + 'px',
//		 'font-size': fontSize + 'px',
//		 'text-align': 'center',
//		 });
//	
//	//説明エリア
//	$('#PPexplainArea')
//	.css({
//		 'width': cs * 1.3 - cellSize / 2 + 'px',
//		 'height': cs / 2 + cellSize + 'px',
//		 'position': 'absolute',
//		 'left': cs + cellSize / 2 + 'px',
//		 });
//	//特徴・主な用途
//	fontSize = l;
//	$('#PPfeaturea')
//	.text('特徴・主な用途')
//	.css({
//       'font-family' : 'Arial',
//		 'font-size': fontSize + 'px',
//		 'margin': '0px',
//		 });
//}




//詳細表示用領域セット
var setDetailArea = function() {
	var strAppendElements = '';
	var cs = cellSize * 4;
	var l = cs / 10;
	var fontSize = 0;

	if(!document.getElementById('explainArea')){
		//子要素の追加
		strAppendElements = 
			_createStrElement('div', 'explainArea') +
			_createStrElement('div', 'selectedContent');
		$('#detailArea').append(strAppendElements);

		//孫要素の追加
		strAppendElements = 
			_createStrElement('p', 'featurea') +
			_createStrElement('div', 'selectedContent-detail') +
        _createStrElement('div', 'selectedContent-detail2');
        
		$('#explainArea').append(strAppendElements);

		//孫要素の追加
		strAppendElements =
			_createStrElement('div', 'selectedContent-symbol') +
			_createStrElement('div', 'selectedContent-serialNumber') +
			_createStrElement('div', 'selectedContent-name');
		$('#selectedContent').append(strAppendElements);
	}
	
	//枠
	$('#detailArea')
	.addClass('hidden')
	.css({
		'width': cs * 3.75 + 'px',
		'height': cs + 'px',
		'position': 'absolute',
		'left': cellSize * 2.75 + 'px',
		'top': cellSize * 0.5 + 'px',
		'-webkit-border-radius': cs / 5,
		'-moz-border-radius': cs / 5,
		'border-radius': cs / 5 + 'px',
	});

	//パネル
	$('#selectedContent')
	.addClass('gridButton')
	.css({
		'width': cs  + 'px',
		'height': cs + 'px',
		'position': 'absolute',
		'-webkit-border-radius': cs / 5,
		'-moz-border-radius': cs / 5,
		'border-radius': cs / 5 + 'px',
	});
	//パネル内データ
	//元素記号
	fontSize = l * 6;
	
	symbolFontSizeSmall = (fontSize * 0.8 );
	symbolFontSizeNormal = fontSize;
	
	$('#selectedContent-symbol')
	.css({
		'width': l * 5 + 'px',
		'height': l * 5 + 'px',
		'position': 'absolute',
		'left': l * 1 + 'px',
		'top': '0px' , 
		'font-size': fontSize + 'px',
		'text-align': 'center',
		'letter-spacing': fontSize * (-0.05) + 'px',
	});
	//原子番号
	fontSize = l * 2;
	$('#selectedContent-serialNumber')
	.css({
		'width': l * 2 + 'px',
		'height': l * 2 + 'px',
		'position': 'absolute',
		'left': l * 6 + 'px',
		'top': l / 2 + 'px',
		'font-size': fontSize + 'px',
		'text-align': 'right',
	});
	//元素名
	fontSize = l * 1.3;
		
	nameFontSizeSmall = (fontSize * 0.7 ) + 'px';
	nameFontSizeNormal = fontSize + 'px';
	
	$('#selectedContent-name')
	.css({
		'width': l * 9 + 'px',
		'height': l * 1 + 'px',
		'position': 'absolute',
		'left': l - ( fontSize / 2 ) + 'px',
		'top': l * 8.0 + 'px',
		'font-family': 'Arial','font-weight': 'bold',
		'font-size': fontSize + 'px',
		'text-align': 'center',
	});

	//説明エリア
	$('#explainArea')
	.css({
		'width': cs * 2.75 - cellSize / 2 + 'px',
		'height': cs / 3 + cellSize * 0.75 + 'px',
		'position': 'absolute',
		'left': cs + cellSize / 2 + 'px',
	});
	//特徴・主な用途
	fontSize = l * 1.5;
	$('#featurea')
	.text('特徴・主な用途')
	.css({
         'font-family' : 'Arial',
		'font-size': fontSize + 'px',
		'margin': '0px',
	});
	fontSize = l;
	//説明
	$('#selectedContent-detail').css({
		'font-family': 'Arial','font-weight': 'bold',
		'font-size': fontSize + 'px',
		'margin-top': cellSize / 4 + 'px'
	})
}

//グリッド生成
var createGrid = function(argGridId, argNumRow, argNumColumn, argShowHeadline) {
	var grid = {};
	var strRowElement = '';
	var strCellElement = '';
	var rowId = '';
	var cellId = '';
	var positionLeft = 0;
	var positionTop = 0;
	var rowSelector = {};
	var cellSelector = {};
	var headlineShortLength = cellSize / 2;

	for (var r = 0; r <= argNumRow; r++) {
		//見出しがない場合は0番目を飛ばす
		if(r == 0 && !argShowHeadline) {
			continue;
		}
		//行要素
		rowId = argGridId + '-row' + r;
		strRowElement = _createStrElement('div', rowId);
		$('#' + argGridId).append(strRowElement);
		rowSelector = $('#' + rowId);
		rowSelector.css({
			'line-height': '0px',
			'height': cellSize + 'px',
			'position': 'absolute',
			'left': '0px',
			'top': positionTop + 'px',
		});

		positionLeft = 0;
		for (var c = 0; c <= argNumColumn; c++) {
			//見出しがない場合は0番目を飛ばす
			if(c == 0 && !argShowHeadline) {
				continue;
			}
			//セル要素
			cellId = argGridId + '-r' + r + 'c' + c;
			strCellElement = _createStrElement('div', cellId);
			rowSelector.append(strCellElement);	
			cellSelector = $('#' + cellId);
			cellSelector.addClass(
				 argGridId + ' ' +
				'r' + r + ' ' +
				'c' + c + ' ' +
				'hidden' + ' ' +	//デフォルトは非表示にしておく
				'gridButton'
			)
			.css({
				'width': cellSize + 'px',
				'height': cellSize + 'px',
				'position': 'absolute',
				'left': positionLeft + 'px',
				'top': '0px',
				'-webkit-border-radius': cellSize / 5,
				'-moz-border-radius': cellSize / 5,
				'border-radius': cellSize / 5 + 'px',
			});

			if(c == 0) {
				//見出し
				positionLeft = positionLeft + headlineShortLength;
			} else {
				positionLeft = positionLeft + cellSize;
			}
			positionLeft = positionLeft + cellSize / 25;		//横間隔

			//見出しの値設定
			if(argShowHeadline) {
				var l = cellSize / 10;

				if(r != 0 && c == 0) {
					//行番号
					//子要素の追加
					strAppendElements = _createStrElement('div', cellId + '-headline')
					cellSelector.append(strAppendElements);
					//見出し番号
					$('#' + cellId + '-headline')
					.addClass('headline')
					.text(r)
					.css({
						'width': headlineShortLength + 'px',
						'height': cellSize + 'px',
						'position': 'absolute',
						'left': '0px',
						'top': '0px',
						'margin-top': cellSize / 2 + 'px',
						'margin-bottom': cellSize / 2 + 'px',
						'font-size': headlineShortLength + 'px',
						'text-align': 'center',
					});
				} else if(r == 0 && c != 0) {
					//列番号
					//子要素の追加
					strAppendElements = _createStrElement('div', cellId + '-headline')
					cellSelector.append(strAppendElements);
					//見出し番号
					$('#' + cellId + '-headline')
					.addClass('headline')
					.text(c)
					.css({
						'width': cellSize + 'px',
						'height': headlineShortLength + 'px',
						'position': 'absolute',
						'left': '0px',
						'top': '0px',
						'margin-top': headlineShortLength / 2 + 'px',
						'margin-bottom': headlineShortLength / 2 + 'px',
						'font-size': headlineShortLength + 'px',
						'text-align': 'center',
					});
				}
			}
		}

		if(r == 0) {
			//見出
			positionTop = positionTop + headlineShortLength
		} else {
			positionTop = positionTop + cellSize;
		}
		positionTop = positionTop + cellSize / 25;		//縦間隔
	}

	//見出しの表示切替え
	if(argShowHeadline) {
		$('.r0')
		.toggleClass('hidden')
		.css({
			'width': cellSize + 'px',
			'height': headlineShortLength + 'px',
			'-webkit-border-radius': cellSize / 5,
			'-moz-border-radius': cellSize / 5,
			'border-radius': cellSize / 5 + 'px',
		});
		$('.c0')
		.toggleClass('hidden')
		.css({
			'width': headlineShortLength + 'px',
			'height': cellSize + 'px',
			'-webkit-border-radius': cellSize / 5,
			'-moz-border-radius': cellSize / 5,
			'border-radius': cellSize / 5 + 'px',
		});
	}

	//グリッドエリアの確保
	$('#' + argGridId).css({
		'width': positionLeft + 'px',
		'height': positionTop + 'px',
	});
};

//データ注入(個別版)
var insertContents2Grid = function(argGridId, argArrSet) {
	var cellId = '';
	var arrGridContents = argArrSet[0];
	var type2Insert = argArrSet[1];
	var strAppendElements = '';
	var cellSelector = {};
	var l = cellSize / 10;
	var fontSize = 0;
	var mtop = 0;

	for (var i = 0; i < arrGridContents.length; i++) {
		//各元素のバインド処理
		cellId = arrGridContents[i].type + 'Grid-r' + arrGridContents[i].row + 'c' + arrGridContents[i].column;
		if(arrGridContents[i].name && arrGridContents[i].type == type2Insert) {
			cellSelector = $('#' + cellId);
			//セルの表示
			cellSelector.toggleClass('hidden');

			//イベントバインド
			cellSelector.bind('click', {'id':cellId, 'gridContent': arrGridContents[i], 'gridContentIndex': i}, onClickGridContent);

			//子要素の追加
			strAppendElements =
				_createStrElement('div', cellId + '-symbol') +
				_createStrElement('div', cellId + '-serialNumber'); // +
				//_createStrElement('div', cellId + '-name');		//現行にはないので消すならここも消す
			cellSelector.append(strAppendElements);

			//セル内データ
			//元素記号
			fontSize = l * 6;
			mtop = fontSize / 2;
			// 3文字の場合はフォントサイズを下げる
			if ( arrGridContents[i].symbol.length >= 3 ) {
				fontSize = l * 4;
				mtop = fontSize / 2 + 5;
			}
			
			//
			$('#' + cellId).css({'backgroundColor' : arrGridContents[i].color});
			coloredHash[cellId] = arrGridContents[i].color;
			
			$('#' + cellId + '-symbol')
			.addClass('symbol')
			.text(arrGridContents[i].symbol)
			.css({
				'width': l * 5 + 'px',
				'height': l * 5 + 'px',
				'position': 'absolute',
				'left': l + 'px',
				'top': l * 3 + 'px',
				'margin-top': mtop + 'px',
				'margin-bottom': fontSize / 2 + 'px',
				'font-size': fontSize + 'px',
				'text-align': 'center'
			});
			//原子番号
			fontSize = l * 3;
			$('#' + cellId + '-serialNumber')
			.addClass('serialNumber')
			.text(arrGridContents[i].serialNumber)
			.css({
				'width': l * 6 + 'px',
				'height': l * 2 + 'px',
				'position': 'absolute',
				'left': l * 3 + 'px',
				'top': l + 'px',
				'margin-top': fontSize / 2 + 'px',
				'margin-bottom': fontSize / 2 + 'px',
				'font-size': fontSize + 'px',
				'text-align': 'right',
			});
		}
	}
};

//族番号設定
var fitHeadline = function() {
    var d = cellSize * (26/25);			//セルサイズ + 間隔
	$('#mainGrid-r0c2').css('top', 1 * d + 'px');
	$('#mainGrid-r0c3').css('top', 3 * d + 'px');
	$('#mainGrid-r0c4').css('top', 3 * d + 'px');
	$('#mainGrid-r0c5').css('top', 3 * d + 'px');
	$('#mainGrid-r0c6').css('top', 3 * d + 'px');
	$('#mainGrid-r0c7').css('top', 3 * d + 'px');
	$('#mainGrid-r0c8').css('top', 3 * d + 'px');
	$('#mainGrid-r0c9').css('top', 3 * d + 'px');
	$('#mainGrid-r0c10').css('top', 3 * d + 'px');
	$('#mainGrid-r0c11').css('top', 3 * d + 'px');
	$('#mainGrid-r0c12').css('top', 3 * d + 'px');
	$('#mainGrid-r0c13').css('top', 1 * d + 'px');
	$('#mainGrid-r0c14').css('top', 1 * d + 'px');
	$('#mainGrid-r0c15').css('top', 1 * d + 'px');
	$('#mainGrid-r0c16').css('top', 1 * d + 'px');
	$('#mainGrid-r0c17').css('top', 1 * d + 'px');
}

//ランタノイドとアクチノイドをセット
var setLantActi2mainGrid = function() {
	//ランタノイド
	var strAppendElements =
		_createStrElement('div', 'ltxt1', 'ランタ') +
		_createStrElement('div', 'ltxt2', 'ノイド');
	$('#mainGrid-r6c3')
	.append(strAppendElements)
	.css('text-align', 'center')
	.removeClass('gridButton')
	.removeClass('hidden');
	$('#ltxt1').css({
		'font-family': 'Arial','font-weight': 'bold',
		'font-size': cellSize * 0.3 + 'px',
		'position': 'absolute',
		'top': cellSize * 0.3 + 'px',
		'left': cellSize * 0.05 + 'px',
		'position': 'absolute',
	});
	$('#ltxt2').css({
		'font-family': 'Arial','font-weight': 'bold',
		'font-size': cellSize * 0.3 + 'px',
		'position': 'absolute',
		'top': cellSize * 0.7 + 'px',
		'left': cellSize * 0.05 + 'px',
		'position': 'absolute',
	});
	
	//アクチノイド
	strAppendElements =
		_createStrElement('div', 'atxt1', 'アクチ') +
		_createStrElement('div', 'atxt2', 'ノイド');
	$('#mainGrid-r7c3')
	.append(strAppendElements)
	.css('text-align', 'center')
	.removeClass('gridButton')
	.removeClass('hidden');
	$('#atxt1').css({
		'font-family': 'Arial','font-weight': 'bold',
		'font-size': cellSize * 0.3 + 'px',
		'position': 'absolute',
		'top': cellSize * 0.3 + 'px',
		'left': cellSize * 0.05 + 'px',
		'position': 'absolute',
	});
	$('#atxt2').css({
		'font-family': 'Arial','font-weight': 'bold',
		'font-size': cellSize * 0.3 + 'px',
		'position': 'absolute',
		'top': cellSize * 0.7 + 'px',
		'left': cellSize * 0.05 + 'px',
		'position': 'absolute',
	});
	
	//グリッド部の移動
	$('#lanthanoidGrid')
	.css('left', cellSize * (3.5+(4/26)) + 'px');
	$('#actinideGrid')
	.css('left', cellSize * (3.5+(4/26)) + 'px');
	
	//ランタノイド
	$('#lanthanoidHeadline')
	.text('ランタノイド')
	.css({
         'font-family' : 'Arial',
		'font-size': cellSize * 0.55 + 'px',
		'margin-top': cellSize * 0.17 + 'px',
	});
	//アクチノイド
	$('#actinideHeadline')
	.text('アクチノイド')
	.css({
         'font-family' : 'Arial',
		'font-size': cellSize * 0.55 + 'px',
		'margin-top': cellSize * 0.17 + 'px',
	});
}

//HTML要素作成用に文字列を生成して返す
var _createStrElement = function(argElementType, argCellId, argText) {
	var strElement = 
		'<' + argElementType +
		' id="' + argCellId +
		'">' + (argText? argText : '') +
		'</' + argElementType +
		'>';
	return strElement;
}

/*
 * Mixerクラス
 * ランダム選択をマネジメントする
 */
var Mixer = function() {};
//ランダムにする対象の配列を指定する
Mixer.prototype.attach = function(argArr) {
	this._bindArr = argArr;
	for(var i = 0; i < argArr.length; i++) {
		this._randomStack.push(i);
	}
	this.mix();
}
//対象配列のランダムスタックからインデックスを取り出す
Mixer.prototype.pop = function() {
	var randomNumber = this._randomStack.pop();
	return this._bindArr[randomNumber];
}
//対象配列のランダムスタックの最後尾に対象配列インデックスを詰める
Mixer.prototype.push = function(argIndex) {
	this._randomStack.push(argIndex);
}
//対象配列のランダムスタックを再度ミックスする
Mixer.prototype.mix = function() {
	var newArr = [];
	var index = 0;
	var len = this._randomStack.length;
	for(var i = 0; i < len; i++) {
		index = this._getRandomInt(0, this._randomStack.length - 1);
		newArr[i] = this._randomStack[index];
		this._randomStack.splice(index, 1);
	}
	this._randomStack = newArr;
}
//対象配列のランダムスタックから引数に指定した値（対象配列のインデックス）を除去
Mixer.prototype.remove = function(argValue) {
	for(var i = 0; i < this._randomStack.length; i++) {
		if(this._randomStack[i] == argValue) {
			this.splice(i, 1);
			break;
		}
	}
}
//対象配列のランダムスタックからsplice
Mixer.prototype.splice = function(argIndex, arglength) {
	this._randomStack.splice(argIndex, arglength);
}
//取り出した要素のインデックスが入った配列を返す
Mixer.prototype.getPoppedIndexArr = function(argStrRequestArr) {
	var poppedIndexArr = [];
	var isRemoved = true;
	for(var i = 0; i < this._bindArr.length; i++) {
		isRemoved = true;	//初期値はtrueにしておく
		for(var j = 0; j < this._randomStack.length; j++) {
			if(i == this._randomStack[j]) {
				isRemoved = false;
			}
		}
		if(isRemoved) {
			poppedIndexArr.push(i)
		}
	}
	return poppedIndexArr;
}

// -> Mixerクラス private
Mixer.prototype._randomStack = [];
Mixer.prototype._clickedIndexArr = [];
Mixer.prototype._bindArr = [];
// min から max までの乱整数を返す関数
Mixer.prototype._getRandomInt = function(min, max) {
	return Math.floor( Math.random() * (max - min + 1) ) + min;
}
// <- Mixerクラス private;

//ロード時処理呼び出し
$(function() {
	//動的コンテンツロード
	loadDynamicContents();
	//各ボタンにイベントをバインド
	document.getElementById('resetButton').addEventListener('click', onClickResetButton, false);
	//document.getElementById('toggleHeadlineButton').addEventListener('click', onClickToggleHeadlineButton, false);
	document.getElementById('randomButton').addEventListener('click', onClickRandomButton, false);
	document.getElementById('chanceButton').addEventListener('click', onClickChanceButton, false);
	document.getElementById('hintButton').addEventListener('click', onClickHintButton, false);
  
	//BlinkManagerクラスの生成
    bm = new BlinkManager();
});

//リサイズ終了時の処理
$(window).resize(function() {
	if (timer !== false) {
		clearTimeout(timer);
	}
	timer = setTimeout(function() {
		/* リロード前処理 */
		//mixerオブジェクトの選択済みインデックスを退避
		var poppedIndexArr = mixer.getPoppedIndexArr();
		//opacityの状態を覚えておく
		var arrOpacity1 = [];
		for(var i = 0; i < bm.clickedObject.length; i++) {
			if($('#' + bm.clickedObject[i].id).css('opacity') == '1') {
				arrOpacity1.push(bm.clickedObject[i].id);
			}
		}
		//説明エリアの表示状態を覚えておく
		var headLineStatus = $('#detailArea').hasClass('hidden');
		var symbolTop = $('#selectedContent-symbol').css('top');
		symbolTop = symbolTop.substring(0, symbolTop.length - 2);
		var symbolFontSize = $('#selectedContent-symbol').css('font-size');
		symbolFontSize = symbolFontSize.substring(0, symbolFontSize.length - 2);
		var nameFontSize = $('#selectedContent-name').css('font-size');
		nameFontSize = nameFontSize.substring(0, nameFontSize.length - 2);
		//レート算出用にセルサイズを退避
		var beforeCellSize = cellSize;
		//動的要素の削除
		//$('#detailArea').empty();		//こいつは残しておく
		$('#mainGrid').empty();
		$('#lanthanoidHeadline').empty();
		$('#lanthanoidGrid').empty();
		$('#actinideHeadline').empty();
		$('#actinideGrid').empty();

		/* リロード処理 */
		loadDynamicContents();
		//クリック済みの要素のスタイルを変更
		for (var cli in clickedHash) {
			if(clickedHash[cli]) {
				var clickedObject = $('#' + cli);
				clickedObject.addClass('clicked').css({
					'backgroundColor' : '#fc3c3c',
					'opacity': '0',
				});
			}
		}
		//リロード後のmixerオブジェクトの中で，リロード前に選択したものを選択済みにする
		for (var i = 0; i < poppedIndexArr.length; i++) {
			mixer.remove(poppedIndexArr[i]);
		}
		//直前の選択要素は表示する
		//var clickedObject = $(bm.clickedObject.selector);
		//clickedObject.css('opacity', '1');
		for(var i = 0; i < arrOpacity1.length; i++) {
			$('#' + arrOpacity1[i]).css('opacity', '1');
		}
		bm = new BlinkManager();
		bm.init(clickedObject);
		//説明エリアの表示状態を合わせる
		if(!headLineStatus) {
			$('#detailArea').removeClass('hidden');
			$('#selectedContent-symbol').css('top', symbolTop * (cellSize / beforeCellSize) + 'px');
			$('#selectedContent-symbol').css('font-size', symbolFontSize * (cellSize / beforeCellSize) + 'px');
			$('#selectedContent-name').css('font-size', nameFontSize * (cellSize / beforeCellSize) + 'px');
		}
	}, 250);
});
